<?php

function mod($a, $b) {
  return $a-($b * floor($a/$b));
}

function mystrpos($mystring , $findme) {
  $pos = strpos($mystring, $findme);
  if ($pos === false) {
     return -1;
  }
  return $pos;
}

function nollipap($listKey) {
  $list1 = [-7, -2, 20, 11, -4, 7, -4, 17, 4, -1, 9, 4];
  $list2 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]; // deviendra les chiffres des codes touche 1 par 1 
  $list3 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
  $list4 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
  $list5 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

  $str1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ !";
  $str1 .= $str1;
  $str2 = "K!KLI! HXUTCCNJZIUREMFTY";
  $str3 = "";

  $s = 0;
  $t = 0;

  for ($n = 1; $n <= 6; $n++) {
    if ($n<=3) { $s = 100*$s + $listKey[$n-1]; }
    if ($n>3) { $t = 100*$t + $listKey[$n-1]; }
  }

  for ($i = 1; $i <= 6; $i++) {
    $list2[6-$i] = mod($s, 10);
    $s = (int)($s / 10);
    $list2[12-$i] = mod($t, 10);
    $t = (int)($t / 10);
  }
 
  for ($i = 0; $i < count($list1); $i++) {
    $list1[$i] = mod($list1[$i] + $list2[$i], 28);
  }

  for ($i = 0; $i < 24; $i++) {
    $list3[$i] = mystrpos($str1, $str2[$i]);
  }

  for ($i = 0; $i < 12; $i++) {
    $list4[$list1[$i]] = $list2[$i];
  }

  for ($i = 0; $i < 24; $i++) {
    $list5[$i] = mod($list3[$i]+$list4[$i]-1, 28)+1;
  }

  for ($i = 0; $i < 12; $i++) {
    $str3 .= substr($str1, $list5[$list1[$i]],1);
  }

  return $str3;
}

// Le code d'arecibo disait "9L3AF4" donc j'essaye les touches "9" (code interne 54), "L" (25), "3" (52), "A" (76), "F" (26) et "4" (73)
echo nollipap([54, 25, 52, 76, 26, 73])."\n"; // => "AOVPEWSCAFPK"
// .... j'essaye à l'envers (à cause de l'indice 12 où QR est écrit à l'envers)
echo nollipap([73, 26, 76, 52, 25, 54])."\n"; // =>  "REV STEGANO!"

// -- Rush final --

// Maintenant j'essaye 'LINK24' 
echo nollipap([25, 55, 64, 35, 62, 73])."\n"; // =>  " QAPQGAYZBPK"

// Maintenant j'essaye 'LINK24' mais à l'envers
echo nollipap([73, 62, 35, 64, 55, 25])."\n"; // =>  "RCAPAHQJZNEZ"

